% This file take the steady-state the file "todynaremone.mat"
% It writes the dynare file "code_dynare_hat.mod" which is the dynamic model
% to use perturbation techniques
% it doubl check that the steady state is OK, thanks to the "resid" function




clear
warning('off','all');
load todynaremone.mat

Nbin  = eco.Nbin;    %total number of bins
PI    = eco.Matab;
Sp    = eco.Sp;
K     = eco.A-eco.B;
Ltot  = (chi*eco.w)^phi;
Y     = K^alpha*Ltot^(1-alpha);


rho_u        = 0.95;
P            = ones(Nbin,1);
P(eco.indcc) = 0;

fid = fopen('code_dynare_hat.mod', 'w') ;
formatSpec = '%16.8f';



str = ['var\n'] ; fprintf(fid, str);

str = ['u r w FK FL A B K mu TFP Ltot tauk taul Ctot GDP TT \n'] ; fprintf(fid, str);
str = ['ut Kt Ct Bt wt rt Tt tk tl mut Zt GDPt PIt\n'] ; fprintf(fid, str);  



for p = 1:Nbin
    str = ['a',num2str(p),' '] ; fprintf(fid,str);     %  end-of-period
    str = ['at',num2str(p),' '] ; fprintf(fid, str);   % beginning-of-period  
    str = ['c',num2str(p),' '] ; fprintf(fid, str);    
    str = ['psih',num2str(p),' '] ; fprintf(fid, str);    
    str = ['lambda',num2str(p),' '] ; fprintf(fid, str);    
    str = ['lambdat',num2str(p),' '] ; fprintf(fid, str);    % last period 
    if mod(p,10)==0; %multiple de 10
        str = ['\n'] ;         fprintf(fid, str);
    end;
     
end;

str = ['; \n\n'] ; fprintf(fid, str);
str = ['varexo eps; \n\n'] ; fprintf(fid, str);
str = ['parameters\n'] ; fprintf(fid, str);
str = ['beta alpha phi abar delta gamma chi rho_u G  coef coef2;\n\n'] ; fprintf(fid, str);


str = ['alpha','   = ',num2str(alpha),';\n']; fprintf(fid, str); 
str = ['beta','    = ',num2str(beta),';\n']; fprintf(fid, str); 
str = ['phi','     = ',num2str(phi),';\n']; fprintf(fid, str); 
str = ['abar','   = ',num2str(min(eco.aep)),';\n']; fprintf(fid, str); 
str = ['delta','   = ',num2str(delta),';\n']; fprintf(fid, str);
str = ['gamma','   = ',num2str(gamma),';\n']; fprintf(fid, str);
str = ['rho_u','   = ',num2str(rho_u),';\n']; fprintf(fid, str); %HERE
str = ['G','       = ',num2str(G,formatSpec),';\n']; fprintf(fid, str);
str = ['chi','     = ',num2str(chi),';\n']; fprintf(fid, str);

str = ['coef','  = 1.0;\n']; fprintf(fid, str);
str = ['coef2','  = 1.;\n']; fprintf(fid, str);

%%
equa = 1;
tol = 10^-8;  % threshold for transition, to avoid to consider very small transitions

str = ['%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%'] ; fprintf(fid, str); 
str = ['\n\n'] ; fprintf(fid, str);    

Cons1 = (chi^phi)/(1+ 1/phi); % A constant 
str = ['model;\n\n']; fprintf(fid, str);
for h = 1:Nbin  
    nsi = eco.ytype(h);
        
%%%%%%%% Budget constraint  
        str = ['c',num2str(h),' = ',num2str((chi^phi)*(eco.states(nsi)^(1+phi)),formatSpec), '*w^(1+phi) + (1+r)*','at',num2str(h),'-a', num2str(h),'+ TT;']; fprintf(fid, str);str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;
 %%%%%%%% Definition of at constraint  
        str = ['at',num2str(h),' = 10^-10 ']; fprintf(fid, str);
        for hi = 1:Nbin
            if (PI(h,hi))>tol   % hi to h
              str = ['+ ',num2str(Sp(hi)*PI(h,hi)/Sp(h),formatSpec),'*a',num2str(hi),'(-1)']; fprintf(fid, str);
            end
        % if mod(hi,10)==0;str = ['\n'] ;fprintf(fid, str); end;
        end
        str = [';']; fprintf(fid, str);str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;
%%%%%%%% Euler equation
        if P(h)==1 % not constrained
            str = [num2str(eco.xsip(h),formatSpec),'*(c',num2str(h),' - ',num2str(Cons1*eco.states(nsi)^(1+phi),formatSpec),'*w^(1+phi))^-gamma =', num2str(eco.Res(h)/Sp(h),formatSpec),' + beta*(1+r(+1))*(10^-10']; fprintf(fid, str);
            for hp = 1:Nbin                
                    if (PI(hp,h)*eco.xsip(hp))>tol
                        str = ['+ ',num2str((PI(hp,h))*eco.xsip(hp),formatSpec),'*(c',num2str(hp),'(+1) - ',num2str(Cons1*eco.states(eco.ytype(hp))^(1+phi)),'*w(+1)^(1+phi))^-gamma']; fprintf(fid, str);
                    end
                    % if mod(hi,10)==0;str = ['\n'] ;fprintf(fid, str); end;
                
            end
            str = [');']; fprintf(fid, str);str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;
        else
            str = ['a',num2str(h),' =  steady_state(a',num2str(h),');']; fprintf(fid, str);str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;
        end
%%%%%%%% Def PSI
         str = ['psih',num2str(h),'= mu - ',num2str( Pl.omega(h)*eco.xsip(h),formatSpec ),'*(c',num2str(h),' - ',num2str(Cons1*eco.states(eco.ytype(h))^(1+phi),formatSpec),'*w^(1+phi))^-gamma + (lambda',num2str(h),...
             '- (1+r)*lambdat',num2str(h),')*(',num2str(-gamma*eco.xsip(h),formatSpec),')*((c',num2str(h),' - ',num2str(Cons1*eco.states(eco.ytype(h))^(1+phi),formatSpec),'*w^(1+phi))^(-gamma-1));'];fprintf(fid, str);str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;
%%%%%%%% Eleur PSI         
         if P(h)==1
            str = ['psih',num2str(h),'  = beta*(1+r(+1))*(10^-10']; fprintf(fid, str);
            for hp = 1:Nbin
                
                    if (PI(hp,h))>tol   %be careful transpose from h to hp
                        str = ['+ ',num2str((PI(hp,h)),formatSpec),'*psih',num2str(hp),'(+1)']; fprintf(fid, str);
                  
                    % if mod(hi,10)==0;str = ['\n'] ;fprintf(fid, str); end;
                end
            end
            str = [');']; fprintf(fid, str);str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;
        else
            str = ['lambda',num2str(h),' =  0;']; fprintf(fid, str);str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;
        end
%%%%%%%% Def lambdat
        str = ['lambdat',num2str(h),' = 10^-10 ']; fprintf(fid, str);
        for hi = 1:Nbin
            if PI(h,hi)>tol  %be careful transpose
             % str = ['+ ',num2str(PIuS(hi,h),formatSpec),'*Slambda',num2str(hi),'(-1)']; fprintf(fid, str);
              str = ['+ ',num2str((PI(h,hi))*Sp(hi)/Sp(h),formatSpec),'*lambda',num2str(hi),'(-1)']; fprintf(fid, str);
            end
        % if mod(hi,10)==0;str = ['\n'] ;fprintf(fid, str); end;
        end
        str = [';']; fprintf(fid, str);str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;
           
      
    end



%%%%%%%% FOC planner w
str = ['\n']; fprintf(fid, str);
 str = ['mu*Ltot*phi*(FL-w)/w = (w^phi)*( ']; fprintf(fid, str);           
  for hp = 1:Nbin
     
           if Sp(hp)>tol   %be careful transpose from h to hp
                  str = ['+ ',num2str(Sp(hp)*(eco.states(eco.ytype(hp))^(1+phi))*(chi^phi),formatSpec),'*psih',num2str(hp)]; fprintf(fid, str);
           end
           if mod(hp,10)==0;str = ['\n'] ;fprintf(fid, str); end;
      
 end
            str = [');']; fprintf(fid, str);str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;
         

            
            
 %%%%%%%% FOC planner B           
      str = ['mu = coef2*beta*(mu(+1)*(1+FK(+1)));']; fprintf(fid, str); str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;
      %str = ['B = ', num2str(B,formatSpec),';\n'] ; fprintf(fid, str);
      
 %%%%%%%% FOC planner TT      

% str = ['TT =', num2str(TT),';\n']; fprintf(fid, str);  

 
 str = ['0 =     ']; fprintf(fid, str); 
    for hi = 1:Nbin
          if (Sp(hi))>tol
              str = [' +',num2str(Sp(hi),formatSpec) ,'*psih',num2str(hi)]; fprintf(fid, str);
          end
         if mod(hi,10)==0;str = ['\n'] ;fprintf(fid, str); end;
   end             
 str = [';']; fprintf(fid, str);   str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;
 

 
%%%%%%%% Budget contraint of the state 
%str = ['B + GDP -delta*K(-1) +',num2str(1+tauc) ,'*Ctot= G + TT*(1+theta) + (1+r)*B(-1) +r*K(-1) + w*Ltot;\n'] ; fprintf(fid, str);    
str = ['B + GDP -delta*K(-1) = G + TT + B(-1) +r*A(-1) + w*Ltot;'] ; fprintf(fid, str);   str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;
%str = ['G + Ctot + K = GDP - delta*K(-1) + K(-1);\n'] ; fprintf(fid, str);   
%%%%%%%% Financial market eq
str = ['A = B + K;'] ; fprintf(fid, str);str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;
%%%%%%%% Production side
str = ['FL = (1 - alpha)*TFP*(K(-1)/Ltot)^alpha;'] ; fprintf(fid, str);   str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1; 
str = ['FK = alpha*TFP*(K(-1)/Ltot)^(alpha-1)-delta;'] ; fprintf(fid, str);   str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1; 
str = ['u = rho_u*u(-1) + eps;'] ; fprintf(fid, str);    str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;
str = ['TFP = 1 - u;'] ; fprintf(fid, str);  str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;
str = ['Ltot = (chi*w)^phi;'] ; fprintf(fid, str);  str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;
str = ['GDP = TFP*K(-1)^alpha*Ltot^(1-alpha);'] ; fprintf(fid, str);      str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;
  
%%%%%%%% total consumption
str = ['\n'] ;         fprintf(fid, str);
str = ['Ctot ='] ; fprintf(fid, str);    
for h = 1:Nbin
        str = ['+',num2str(Sp(h),formatSpec),'*c',num2str(h)] ; fprintf(fid, str);  
         if mod(h,5)==0; %multiple de 10
        str = ['\n'] ;         fprintf(fid, str);
    end; 
end;
str = [';']; fprintf(fid, str);str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;

%%%%%%%% Taxes
 str = ['tauk = 1-r/FK;'] ; fprintf(fid, str);  str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;
 str = ['taul = 1-w/FL;'] ; fprintf(fid, str);  str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;
 
  %%%%%%%% Saving agents
    str = ['A = '] ; fprintf(fid, str);    
for h = 1:Nbin
        str = ['+', num2str(Sp(h),formatSpec),'*a',num2str(h)] ; fprintf(fid, str);    
    if mod(p,10)==10; tr = ['\n'] ;fprintf(fid, str);end;
    
          
end;
 str = [';']; fprintf(fid, str); str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;
%%%%%%%% FOC planner r            
   str = ['0  = ']; fprintf(fid, str); 
   for hi = 1:Nbin
          if (Sp(hi))>tol
              str = ['+',num2str(Sp(hi),formatSpec),'*at',num2str(hi),'*psih',num2str(hi)]; fprintf(fid, str);
          end
         if mod(hi,10)==0;str = ['\n'] ;fprintf(fid, str); end;
   end
   for hp = 1:Nbin
       
           if Sp(hp)>tol   %be careful transpose from h to hp
                  str = ['- ',num2str(Sp(hp)*eco.xsip(hp),formatSpec),'*lambdat',num2str(hp),'*((c',num2str(hp),' - ',num2str(Cons1*eco.states(eco.ytype(hp))^(1+phi),formatSpec),'*w^(1+phi))^-gamma)']; fprintf(fid, str);
           end
           if mod(hp,10)==0;str = ['\n'] ;fprintf(fid, str); end;
          
      
 end      
str = [';'] ;         fprintf(fid, str);str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;

%%%%%%%% variables in percent deviations 


str = ['ut = 100*u;'] ; fprintf(fid, str);  str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;
str = ['Kt = 100*(K/',num2str(K,formatSpec),'-1);'] ; fprintf(fid, str);  str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;
str = ['Ct = 100*(Ctot/steady_state(Ctot)-1);'] ; fprintf(fid, str);  str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;
%str = ['Bt = 100*((B)/',num2str(B,formatSpec),'-1);\n'] ; fprintf(fid, str);  
str = ['Bt = 100*((B)/',num2str(eco.B,formatSpec),'-1);'] ; fprintf(fid, str);  str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;
str = ['wt = 100*(w/',num2str(eco.w,formatSpec),'-1);'] ; fprintf(fid, str);  str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;
str = ['rt = 100*(r - ',num2str(eco.R-1,formatSpec),');'] ; fprintf(fid, str); str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;
str = ['Tt = 100*(TT/',num2str(eco.Agg.TT,formatSpec),'-1);'] ; fprintf(fid, str);  str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;
str = ['tk = 100*(tauk -',num2str(tk,formatSpec),');'] ; fprintf(fid, str);  str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;
str = ['tl = 100*(taul -',num2str(tl,formatSpec),');'] ; fprintf(fid, str);  str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;
str = ['mut = 100*(mu/',num2str(Pl.mu,formatSpec),'-1);'] ; fprintf(fid, str);  str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;
str = ['Zt = -ut;'] ; fprintf(fid, str);  str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;
str = ['PIt =0;'] ; fprintf(fid, str);  str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;
str = ['GDPt = 100*(GDP/',num2str(Y,formatSpec),'-1);'] ; fprintf(fid, str);  str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;




str = ['\n'] ;         fprintf(fid, str);
str = ['end;\n\n'] ; fprintf(fid, str);    
     
str = ['%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%'] ; fprintf(fid, str);    
str = ['\n\n'] ; fprintf(fid, str);    
     
%%    
str = ['steady_state_model;\n\n'] ; fprintf(fid, str);   
%str = ['initval;\n\n'] ; fprintf(fid, str);   
for h = 1:Nbin
    str = ['a',num2str(h),' = ',num2str(eco.aep(h)/Sp(h),formatSpec),';\n'] ; fprintf(fid, str);    
    str = ['at',num2str(h),' = ',num2str(eco.abp(h)/Sp(h),formatSpec),';\n'] ; fprintf(fid, str);    
    str = ['c',num2str(h),' = ',num2str(eco.cp(h)/Sp(h),formatSpec),';\n'] ; fprintf(fid, str);    
    str = ['lambda',num2str(h),' = ',num2str(Pl.lambda(h),formatSpec),';\n'] ; fprintf(fid, str);    
    str = ['lambdat',num2str(h),' = ',num2str(Pl.lambdat(h),formatSpec),';\n'] ; fprintf(fid, str);    
    str = ['psih',num2str(h),' = ',num2str(Pl.psih(h),formatSpec),';\n'] ; fprintf(fid, str);    
   
 end;
 
str = ['r = ', num2str(eco.R-1,formatSpec),';\n'] ; fprintf(fid, str);
str = ['w = ', num2str(eco.w,formatSpec),';\n'] ; fprintf(fid, str);
str = ['FK = ', num2str((1/beta-1),formatSpec),';\n'] ; fprintf(fid, str);
str = ['FL = ', num2str(1*eco.w/(1-tl),formatSpec),';\n'] ; fprintf(fid, str);
%str = ['FL = ', num2str(w/(1-taul),formatSpec),';\n'] ; fprintf(fid, str);
str = ['K = ', num2str(K,formatSpec),';\n'] ; fprintf(fid, str);
str = ['Ltot = (chi*w)^phi;\n'] ; fprintf(fid, str); 
str = ['mu = ', num2str(Pl.mu,formatSpec),';\n'] ; fprintf(fid, str);
str = ['TFP = ', num2str(1),';\n'] ; fprintf(fid, str);
str = ['A = ', num2str(eco.A,formatSpec),';\n'] ; fprintf(fid, str);
str = ['B = ', num2str(eco.B,formatSpec),';\n'] ; fprintf(fid, str);
str = ['u = ', num2str(0),';\n'] ; fprintf(fid, str);

str = ['tauk = ', num2str(tk,formatSpec),';\n'] ; fprintf(fid, str);
str = ['taul = ', num2str(tl,formatSpec),';\n'] ; fprintf(fid, str);
str = ['Ctot = ', num2str(Ctot,formatSpec),';\n'] ; fprintf(fid, str);
str = ['GDP = ', num2str(Y,formatSpec),';\n'] ; fprintf(fid, str);
str = ['TT = ', num2str(eco.Agg.TT,formatSpec),';\n'] ; fprintf(fid, str);



str = ['ut = 0;\n'] ; fprintf(fid, str);  
str = ['Kt = 0;\n'] ; fprintf(fid, str);  
str = ['Ct  = 0;\n'] ; fprintf(fid, str);  
str = ['Bt = 0;\n'] ; fprintf(fid, str);  
str = ['wt = 0;\n'] ; fprintf(fid, str);  
str = ['rt = 0;\n'] ; fprintf(fid, str); 
str = ['Tt = 0;\n'] ; fprintf(fid, str);  
str = ['tk = 0;\n'] ; fprintf(fid, str);  
str = ['tl = 0;\n'] ; fprintf(fid, str);  
str = ['mut = 0;\n'] ; fprintf(fid, str); 
str = ['Zt = 0;\n'] ; fprintf(fid, str); 
str = ['PIt = 0;\n'] ; fprintf(fid, str); 
str = ['GDPt = 0;\n'] ; fprintf(fid, str); 



str = ['end;\n\n'] ; fprintf(fid, str);    

%%
str = ['resid;\n\n'] ; fprintf(fid, str);    
%str = ['options_.solve_tolf=10^-6;\n\n'] ; fprintf(fid, str);   
%str = ['steady(maxit = 100,solve_algo=3);\n\n'] ; fprintf(fid, str);  

%str = ['steady;\n\n'] ; fprintf(fid, str);


str = ['steady(nocheck);\n\n'] ; fprintf(fid, str); 
str = ['check;\n\n'] ; fprintf(fid, str);    
str = ['shocks;\n var eps = 0.0001;\nend;\n'] ; fprintf(fid, str);         

%str = ['stoch_simul (order=1,irf=200, periods=10000,nograph) ut Kt Ct Bt wt rt tk tl mut GDPt Tt PIt K Ctot B w r tauk taul mu GDP Ltot T;'] ; fprintf(fid, str);         
str = ['stoch_simul (order=1,irf=200, periods=10000,nograph) ut Kt Ct Bt wt rt tk tl mut GDPt Tt PIt Ctot K GDP Ltot tauk taul B TT;'] ; fprintf(fid, str);         
dynare code_dynare_hat noclearall

save tofigaggreal ut_eps GDPt_eps Ct_eps wt_eps rt_eps Tt_eps Kt_eps tk_eps tl_eps mut_eps Bt_eps
save totalbeaggreal oo_



    
    
    