clear
warning('off','all');

load todynaremone.mat
%%%%%%%%%%%%%%%%%
% Be careful psih becomes -psih





% %%
% 
% fid         = fopen('simuldyratone.mod', 'w') ;
% formatSpec  = '%16.12f';
% 
% %%%%%%%% importing data
% dataj = importdata('data_.xlsx');
% [L,l] = size(dataj.data);
% for i=1:l
%     H = max(find(not(isnan(dataj.data(:,i)))));
%     string = [char(dataj.textdata(i)),'= (dataj.data(1:',num2str(H),',i));'];
%     eval(string);
% end
% 
% 
% Trans  = reshape(Trans(1:ns*ns),ns,ns);
% PIs    = reshape(PIs(1:(ns*N*ns*N)),ns*N,ns*N);
% 
% % Becareful : not per capita
% PIa    = reshape(PIa(1:(ns*N*ns*N)),ns*N,ns*N);
% PIuS    = reshape(PIu(1:(ns*N*ns*N)),ns*N,ns*N);
% 
% %PIa = PIs;
% %PIu = PIa';

%



Nbin  = eco.Nbin;    %total number of bins
PI    = eco.Matab;
Sp    = eco.Sp;
K     = eco.A-eco.B;
Ltot  = (chi*eco.w)^phi;
Y     = K^alpha*Ltot^(1-alpha);


rho_u = 0.95;



P            = ones(Nbin,1);
P(eco.indcc) = 0;

fid = fopen('code_dynare_hat_nK.mod', 'w') ;
formatSpec = '%16.8f';



str = ['var\n'] ; fprintf(fid, str);

str = ['u r w FK FL A B K mu TFP Ltot tauk taul Ctot GDP TT \n'] ; fprintf(fid, str);
str = ['ut Kt Ct Bt wt rt GDPt PIt rtildeK wtilde Tt tk tl mut Zt zeta Lgamma M PI RBN Gamma Upsilon \n'] ; fprintf(fid, str);  % Lgamma is the multplier of the NK-Philipps curve


for p = 1:Nbin
    str = ['a',num2str(p),' '] ; fprintf(fid,str);     %  end-of-period
    str = ['at',num2str(p),' '] ; fprintf(fid, str);   % beginning-of-period  
    str = ['c',num2str(p),' '] ; fprintf(fid, str);    
    str = ['psih',num2str(p),' '] ; fprintf(fid, str);    
    str = ['lambda',num2str(p),' '] ; fprintf(fid, str);    
    str = ['lambdat',num2str(p),' '] ; fprintf(fid, str);    % last period 
    if mod(p,10)==0; %multiple de 10
        str = ['\n'] ;         fprintf(fid, str);
    end;
     
end;

str = ['; \n\n'] ; fprintf(fid, str);

str = ['varexo eps; \n\n'] ; fprintf(fid, str);


str = ['parameters\n'] ; fprintf(fid, str);




%for h = 1:fin
%   str = ['xsi',num2str(h),' '] ; fprintf(fid, str);    
%    str = ['S',num2str(h),' '] ; fprintf(fid, str);    
%        if mod(h,10)==0;str = ['\n'] ;fprintf(fid, str); end;  
%end;

str = ['beta alpha phi abar delta gamma chi rho_u G  coef coef2 kappa epss;\n\n'] ; fprintf(fid, str);


str = ['alpha','   = ',num2str(alpha),';\n']; fprintf(fid, str); 
str = ['beta','    = ',num2str(beta),';\n']; fprintf(fid, str); 
str = ['phi','     = ',num2str(phi),';\n']; fprintf(fid, str); 
str = ['abar','   = ',num2str(min(eco.aep)),';\n']; fprintf(fid, str); 
str = ['delta','   = ',num2str(delta),';\n']; fprintf(fid, str);
str = ['gamma','   = ',num2str(gamma),';\n']; fprintf(fid, str);
str = ['rho_u','   = ',num2str(rho_u),';\n']; fprintf(fid, str); %HERE
str = ['G','       = ',num2str(G,formatSpec),';\n']; fprintf(fid, str);
str = ['chi','     = ',num2str(chi),';\n']; fprintf(fid, str);

str = ['coef  = 1.0;\n']; fprintf(fid, str);
str = ['coef2 = 1.0;\n']; fprintf(fid, str);

epss = 6;
kappa = 100;

str = ['epss','   = ',num2str(epss),';\n\n\n']; fprintf(fid, str);
str = ['kappa','   = ',num2str(kappa),';\n\n\n']; fprintf(fid, str);



%%
equa = 1;
tol = 10^-8;  % threshold for transition, to avoid to consider very small transitions

str = ['%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%'] ; fprintf(fid, str); 
str = ['\n\n'] ; fprintf(fid, str);    

Cons1 = (chi^phi)/(1+ 1/phi);



str = ['model;\n\n']; fprintf(fid, str);
 
for h = 1:Nbin  
    nsi = eco.ytype(h);
        
%%%%%%%% Budget constraint  
        str = ['c',num2str(h),' = ',num2str((chi^phi)*(eco.states(nsi)^(1+phi)),formatSpec), '*w^(1+phi) + (1+r)*','at',num2str(h),'-a', num2str(h),'+ TT;']; fprintf(fid, str);str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;
 %%%%%%%% Definition of at constraint  
        str = ['at',num2str(h),' = 10^-10 ']; fprintf(fid, str);
        for hi = 1:Nbin
            if (PI(h,hi))>tol   % hi to h
              str = ['+ ',num2str(Sp(hi)*PI(h,hi)/Sp(h),formatSpec),'*a',num2str(hi),'(-1)']; fprintf(fid, str);
            end
        % if mod(hi,10)==0;str = ['\n'] ;fprintf(fid, str); end;
        end
        str = [';']; fprintf(fid, str);str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;
%%%%%%%% Euler equation
        if P(h)==1 % not constrained
            str = [num2str(eco.xsip(h),formatSpec),'*(c',num2str(h),' - ',num2str(Cons1*eco.states(nsi)^(1+phi),formatSpec),'*w^(1+phi))^-gamma =', num2str(eco.Res(h)/Sp(h),formatSpec),' + beta*(1+r(+1))*(10^-10']; fprintf(fid, str);
            for hp = 1:Nbin                
                    if (PI(hp,h)*eco.xsip(hp))>tol
                        str = ['+ ',num2str((PI(hp,h))*eco.xsip(hp),formatSpec),'*(c',num2str(hp),'(+1) - ',num2str(Cons1*eco.states(eco.ytype(hp))^(1+phi)),'*w(+1)^(1+phi))^-gamma']; fprintf(fid, str);
                    end
                    % if mod(hi,10)==0;str = ['\n'] ;fprintf(fid, str); end;
                
            end
            str = [');']; fprintf(fid, str);str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;
        else
            str = ['a',num2str(h),' =  steady_state(a',num2str(h),');']; fprintf(fid, str);str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;
        end
        
%%%%%%%% Def PSI
         str = ['psih',num2str(h),'=-  mu + ',num2str( Pl.omega(h)*eco.xsip(h),formatSpec ),'*(c',num2str(h),' - ',num2str(Cons1*eco.states(eco.ytype(h))^(1+phi),formatSpec),'*w^(1+phi))^-gamma - (lambda',num2str(h),...
             '- (1+r)*lambdat',num2str(h),' + (( Lgamma - Lgamma(-1) )*PI*(PI-1) - ((epss-1)/kappa)*Lgamma*(zeta-1))*GDP*',num2str(Pl.omega(h),formatSpec ),')*',num2str(-gamma*eco.xsip(h),formatSpec),'*(c',num2str(h),' - ',num2str(Cons1*eco.states(eco.ytype(h))^(1+phi),formatSpec),'*w^(1+phi))^(-gamma-1);'];fprintf(fid, str);str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;
%%%%%%%% Eleur PSI         
         if P(h)==1
            str = ['psih',num2str(h),'  = beta*(1+r(+1))*(10^-10']; fprintf(fid, str);
            for hp = 1:Nbin
                
                    if (PI(hp,h))>tol   %be careful transpose from h to hp
                        str = ['+ ',num2str((PI(hp,h)),formatSpec),'*psih',num2str(hp),'(+1)']; fprintf(fid, str);
                  
                    % if mod(hi,10)==0;str = ['\n'] ;fprintf(fid, str); end;
                end
            end
           
            str = [')+beta*Gamma(+1)*(r(+1) - (1-tauk)*(RBN/PI(+1)-1));']; fprintf(fid, str);str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;
        else
            str = ['lambda',num2str(h),' =  0;']; fprintf(fid, str);str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;
        end
%%%%%%%% Def lambdat
        str = ['lambdat',num2str(h),' = 10^-10 ']; fprintf(fid, str);
        for hi = 1:Nbin
            if PI(h,hi)>tol  %be careful transpose
             % str = ['+ ',num2str(PIuS(hi,h),formatSpec),'*Slambda',num2str(hi),'(-1)']; fprintf(fid, str);
              str = ['+ ',num2str((PI(h,hi))*Sp(hi)/Sp(h),formatSpec),'*lambda',num2str(hi),'(-1)']; fprintf(fid, str);
            end
        % if mod(hi,10)==0;str = ['\n'] ;fprintf(fid, str); end;
        end
        str = [';']; fprintf(fid, str);str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;
           
      
    end



%%%%%%%% FOC planner w
str = ['\n']; fprintf(fid, str);
 str = ['mu*phi*((1-alpha)*(GDP)*(1-kappa*(PI-1)*(PI-1)/2) - Ltot*w)/w = - (w^phi)*( ']; fprintf(fid, str);           
  for hp = 1:Nbin
     
           if Sp(hp)>tol   %be careful transpose from h to hp
                  str = ['+ ',num2str(Sp(hp)*(eco.states(eco.ytype(hp))^(1+phi))*(chi^phi),formatSpec),'*psih',num2str(hp)]; fprintf(fid, str);
           end
           if mod(hp,10)==0;str = ['\n'] ;fprintf(fid, str); end;
      
 end
            str = [' )+((1-alpha)*phi/w)*( (Lgamma- Lgamma(-1))*PI*(PI-1)+ ((epss-1)/kappa)*Lgamma)*GDP*M ;']; fprintf(fid, str);str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;
         
            
%str = ['taul = steady_state(taul);'] ; fprintf(fid, str);  str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;                        
            
            
 %%%%%%%% FOC planner B           
      str = ['mu = coef2*beta*mu(+1)*(1 - delta + (rtildeK(+1) + delta)*(1-kappa*(PI(+1)-1)*(PI(+1)-1)/2)/zeta(+1) ) + beta*( ((epss-1)/kappa)*Lgamma(+1)*(zeta(+1)-alpha) - alpha*( Lgamma(+1) - Lgamma )*PI(+1)*(PI(+1)-1) )*GDP(+1)*M(+1)/K+']; fprintf(fid, str); 
       str = [' +beta*(1-tauk)*Gamma(+1)*(RBN/PI(+1)-1-rtildeK(+1) ) ;']; fprintf(fid, str);str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;
      %str = ['B = ', num2str(B,formatSpec),';\n'] ; fprintf(fid, str);
      
 %%%%%%%% FOC planner r            
   str = ['0  = ']; fprintf(fid, str); 
   for hi = 1:Nbin
          if (Sp(hi))>tol
              str = ['+',num2str(Sp(hi),formatSpec),'*at',num2str(hi),'*psih',num2str(hi)]; fprintf(fid, str);
          end
         if mod(hi,10)==0;str = ['\n'] ;fprintf(fid, str); end;
   end
   for hp = 1:Nbin     
           if Sp(hp)>tol   %be careful transpose from h to hp
                  str = ['+ ',num2str(Sp(hp)*eco.xsip(hp),formatSpec),'*lambdat',num2str(hp),'*((c',num2str(hp),' - ',num2str(Cons1*eco.states(eco.ytype(hp))^(1+phi),formatSpec),'*w^(1+phi))^-gamma)']; fprintf(fid, str);
           end
           if mod(hp,10)==0;str = ['\n'] ;fprintf(fid, str); end;  
 end      
str = ['+Gamma*(B(-1)+K(-1));'] ;         fprintf(fid, str);str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;


 %%%%%%%% FOC planner PI   
 str = ['0 = mu*kappa*(PI-1) + (Lgamma- Lgamma(-1))*(2*PI-1)*M +(Gamma*(1-tauk)*B(-1) - Upsilon(-1))*RBN(-1)/(PI*PI*GDP)  ;']; fprintf(fid, str); str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;
      
 
 %%%%%%%% FOC planner TT      
%str = ['TT =', num2str(eco.Agg.TT,formatSpec),';\n']; fprintf(fid, str);   str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1; 
 str = ['0 =     ']; fprintf(fid, str); 
    for hi = 1:Nbin
          if (Sp(hi))>tol
              str = [' +',num2str(Sp(hi),formatSpec) ,'*psih',num2str(hi)]; fprintf(fid, str);
          end
         if mod(hi,10)==0;str = ['\n'] ;fprintf(fid, str); end;
   end             
 str = [';']; fprintf(fid, str);   str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;
 
 %%%%%%%% Definition Pricing kernerl M
 
    str = ['M = '] ; fprintf(fid, str);    
for h = 1:Nbin
        str = ['+', num2str(Sp(h)*eco.xsip(h)*Pl.omega(h),formatSpec),'*((c',num2str(h),' - ',num2str(Cons1*eco.states(eco.ytype(h))^(1+phi),formatSpec),'*w^(1+phi))^-gamma)'] ; fprintf(fid, str);    
    if mod(p,10)==10; tr = ['\n'] ;fprintf(fid, str);end;      
end;
 str = [';']; fprintf(fid, str); str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;
 
 
 %%%%%%%% Derivative with respect RBN
  str = ['(1-tauk)*(Gamma(+1)/PI(+1))*B =  Upsilon/PI(+1);']; fprintf(fid, str); str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;
 
%%%%%%%% Derivative with respect rtildeK
  str = ['Upsilon(-1) = ( M*Lgamma*(epss-1)/(kappa*alpha)  - Gamma*(1-tauk) ) *K(-1);']; fprintf(fid, str);  str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;
  
  
 %%%%%%%% NK Philipps curve
 str = ['GDP*M*PI*(PI-1) = ((epss-1)/kappa)*(zeta-1)*GDP*M + beta*PI(+1)*(PI(+1)-1)*GDP(+1)*M(+1);']; fprintf(fid, str); str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;
 
%%%%%%%% Budget contraint of the state 
%str = ['B + GDP -delta*K(-1) +',num2str(1+tauc) ,'*Ctot= G + TT*(1+theta) + (1+r)*B(-1) +r*K(-1) + w*Ltot;\n'] ; fprintf(fid, str);    
str = ['B + GDP*(1-kappa*(PI-1)*(PI-1)/2) -delta*K(-1) = G + TT + B(-1) +r*A(-1) + w*Ltot;'] ; fprintf(fid, str);   str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;
%str = ['G + Ctot + K = GDP - delta*K(-1) + K(-1);\n'] ; fprintf(fid, str);   
%%%%%%%% Financial market eq
str = ['A = B + K;'] ; fprintf(fid, str);str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;
%%%%%%%% Production side
str = ['FL = (1 - alpha)*TFP*(K(-1)/Ltot)^alpha;'] ; fprintf(fid, str);   str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1; 
str = ['FK = alpha*TFP*(K(-1)/Ltot)^(alpha-1)-delta;'] ; fprintf(fid, str);   str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1; 
str = ['u = rho_u*u(-1) + eps;'] ; fprintf(fid, str);    str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;
str = ['TFP = 1 - u;'] ; fprintf(fid, str);  str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;
str = ['Ltot = (chi*w)^phi;'] ; fprintf(fid, str);  str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;
str = ['GDP = TFP*K(-1)^alpha*Ltot^(1-alpha);'] ; fprintf(fid, str);      str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;
  
str = ['zeta = (1/(alpha*TFP))*(rtildeK + delta)*(K(-1)/Ltot)^(1-alpha);'] ; fprintf(fid, str);      str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;
str = ['K(-1)/Ltot = alpha*wtilde/((1-alpha)*(rtildeK+delta));'] ; fprintf(fid, str);      str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;

str = ['RBN = PI(+1)*(1+rtildeK(+1));'] ; fprintf(fid, str);      str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;
str = ['(r - (1-tauk)*rtildeK)*A(-1) = (1-tauk)*(RBN(-1)/PI - 1- rtildeK)*B(-1);'] ; fprintf(fid, str);      str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;

%%%%%%%% total consumption
str = ['\n'] ;         fprintf(fid, str);
str = ['Ctot ='] ; fprintf(fid, str);    
for h = 1:Nbin
        str = ['+',num2str(Sp(h),formatSpec),'*c',num2str(h)] ; fprintf(fid, str);  
         if mod(h,5)==0; %multiple de 10
        str = ['\n'] ;         fprintf(fid, str);
    end; 
end;
str = [';']; fprintf(fid, str);str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;

%%%%%%%% Taxes
 str = ['tauk = steady_state(tauk);'] ; fprintf(fid, str);  str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;
 %str = ['tauk = 1-r/rtilde;'] ; fprintf(fid, str);  str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;
 str = ['taul = 1-w/wtilde;'] ; fprintf(fid, str);  str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;
 
  %%%%%%%% Saving agents
    str = ['A = '] ; fprintf(fid, str);    
for h = 1:Nbin
        str = ['+', num2str(Sp(h),formatSpec),'*a',num2str(h)] ; fprintf(fid, str);    
    if mod(p,10)==10; tr = ['\n'] ;fprintf(fid, str);end;
    
          
end;
 str = [';']; fprintf(fid, str); str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;
%%%%%%%% variables in percent deviations 


str = ['ut = 100*u;'] ; fprintf(fid, str);  str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;
str = ['Kt = 100*(K/',num2str(K,formatSpec),'-1);'] ; fprintf(fid, str);  str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;
str = ['Ct = 100*(Ctot/steady_state(Ctot)-1);'] ; fprintf(fid, str);  str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;
%str = ['Bt = 100*((B)/',num2str(B,formatSpec),'-1);\n'] ; fprintf(fid, str);  
str = ['Bt = 100*((B)/',num2str(eco.B,formatSpec),'-1);'] ; fprintf(fid, str);  str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;
str = ['wt = 100*(w/',num2str(eco.w,formatSpec),'-1);'] ; fprintf(fid, str);  str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;
str = ['rt = 100*(r - ',num2str(eco.R-1,formatSpec),');'] ; fprintf(fid, str); str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;
str = ['Tt = 100*(TT/',num2str(eco.Agg.TT,formatSpec),'-1);'] ; fprintf(fid, str);  str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;
str = ['tk = 100*(tauk -',num2str(tk,formatSpec),');'] ; fprintf(fid, str);  str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;
str = ['tl = 100*(taul -',num2str(tl,formatSpec),');'] ; fprintf(fid, str);  str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;
str = ['mut = 100*(mu/',num2str(Pl.mu,formatSpec),'-1);'] ; fprintf(fid, str);  str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;
str = ['PIt = 100*(PI-1);'] ; fprintf(fid, str);  str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;
str = ['GDPt = 100*(GDP/',num2str(Y,formatSpec),'-1);'] ; fprintf(fid, str);  str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;


str = ['Zt = -ut;'] ; fprintf(fid, str);  str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;




str = ['\n'] ;         fprintf(fid, str);
str = ['end;\n\n'] ; fprintf(fid, str);    
     
str = ['%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%'] ; fprintf(fid, str);    
str = ['\n\n'] ; fprintf(fid, str);    
     
%%    
str = ['steady_state_model;\n\n'] ; fprintf(fid, str);   
%str = ['initval;\n\n'] ; fprintf(fid, str);   
for h = 1:Nbin
    str = ['a',num2str(h),' = ',num2str(eco.aep(h)/Sp(h),formatSpec),';\n'] ; fprintf(fid, str);    
    str = ['at',num2str(h),' = ',num2str(eco.abp(h)/Sp(h),formatSpec),';\n'] ; fprintf(fid, str);    
    str = ['c',num2str(h),' = ',num2str(eco.cp(h)/Sp(h),formatSpec),';\n'] ; fprintf(fid, str);    
    str = ['lambda',num2str(h),' = ',num2str(Pl.lambda(h),formatSpec),';\n'] ; fprintf(fid, str);    
    str = ['lambdat',num2str(h),' = ',num2str(Pl.lambdat(h),formatSpec),';\n'] ; fprintf(fid, str);    
    str = ['psih',num2str(h),' = ',num2str(-Pl.psih(h),formatSpec),';\n'] ; fprintf(fid, str);    
   
 end;
 
str = ['r = ', num2str(eco.R-1,formatSpec),';\n'] ; fprintf(fid, str);
str = ['w = ', num2str(eco.w,formatSpec),';\n'] ; fprintf(fid, str);
str = ['FK = ', num2str((1/beta-1),formatSpec),';\n'] ; fprintf(fid, str);
str = ['FL = ', num2str(1*eco.w/(1-tl),formatSpec),';\n'] ; fprintf(fid, str);
%str = ['FL = ', num2str(w/(1-taul),formatSpec),';\n'] ; fprintf(fid, str);
str = ['K = ', num2str(K,formatSpec),';\n'] ; fprintf(fid, str);
str = ['Ltot = (chi*w)^phi;\n'] ; fprintf(fid, str); 
str = ['mu = ', num2str(Pl.mu,formatSpec),';\n'] ; fprintf(fid, str);
str = ['TFP = ', num2str(1),';\n'] ; fprintf(fid, str);
str = ['A = ', num2str(eco.A,formatSpec),';\n'] ; fprintf(fid, str);
str = ['B = ', num2str(eco.B,formatSpec),';\n'] ; fprintf(fid, str);
str = ['u = ', num2str(0),';\n'] ; fprintf(fid, str);

str = ['tauk = ', num2str(tk,formatSpec),';\n'] ; fprintf(fid, str);
str = ['taul = ', num2str(tl,formatSpec),';\n'] ; fprintf(fid, str);
str = ['Ctot = ', num2str(Ctot,formatSpec),';\n'] ; fprintf(fid, str);
str = ['GDP = ', num2str(Y,formatSpec),';\n'] ; fprintf(fid, str);
str = ['TT = ', num2str(eco.Agg.TT,formatSpec),';\n'] ; fprintf(fid, str);

str = ['PI   = 1;\n'] ; fprintf(fid, str);
str = ['zeta = 1;\n'] ; fprintf(fid, str);
str = ['Lgamma = 0;\n'] ; fprintf(fid, str);
str = ['Gamma = 0;\n'] ; fprintf(fid, str);
str = ['Upsilon = 0;\n'] ; fprintf(fid, str);

str = ['M = ', num2str(M,formatSpec),';\n'] ; fprintf(fid, str);
str = ['rtildeK = r/(1-tauk);\n'] ; fprintf(fid, str);
str = ['RBN = 1+rtildeK;\n'] ; fprintf(fid, str);
str = ['wtilde =FL;\n'] ; fprintf(fid, str);


str = ['ut = 0;\n'] ; fprintf(fid, str);  
str = ['Kt = 0;\n'] ; fprintf(fid, str);  
str = ['Ct  = 0;\n'] ; fprintf(fid, str);  
str = ['Bt = 0;\n'] ; fprintf(fid, str);  
str = ['wt = 0;\n'] ; fprintf(fid, str);  
str = ['rt = 0;\n'] ; fprintf(fid, str); 
str = ['Tt = 0;\n'] ; fprintf(fid, str);  
str = ['tk = 0;\n'] ; fprintf(fid, str);  
str = ['tl = 0;\n'] ; fprintf(fid, str);  
str = ['mut = 0;\n'] ; fprintf(fid, str); 
str = ['Zt = 0;\n'] ; fprintf(fid, str); 
str = ['PIt = 0;\n'] ; fprintf(fid, str); 
str = ['GDPt = 0;\n'] ; fprintf(fid, str); 



str = ['end;\n\n'] ; fprintf(fid, str);    

%%
str = ['resid;\n\n'] ; fprintf(fid, str);    


str = ['steady(nocheck);\n\n'] ; fprintf(fid, str); 
str = ['check;\n\n'] ; fprintf(fid, str);    
str = ['shocks;\n var eps = 0.0001;\nend;\n'] ; fprintf(fid, str);         
%str = ['stoch_simul (order=1,irf=200, periods=10000,nograph) ut Kt Ct Bt wt rt tk tl mut GDPt Tt PIt K Ctot B w r tauk taul mu GDP Ltot T;'] ; fprintf(fid, str);         
str = ['stoch_simul (order=1,irf=200, periods=10000,nograph) ut Kt Ct Bt wt rt tk tl mut GDPt Tt PIt Ctot K GDP Ltot tauk taul B TT rtildeK;'] ; fprintf(fid, str);         
dynare code_dynare_hat_nK noclearall

%save tofigaggnk ut_eps GDPt_eps Ct_eps wt_eps rt_eps Tt_eps Kt_eps PIt_eps tk_eps tl_eps mut_eps Bt_eps
%save totableaggnk oo_
  

%save result_fullnknT % all result of the model.
%% This part simulate the model with lagrange multipliers set to 0 
tic
 load result_fullnK % all result of the model.
M_.endo_names(M_.state_var); % list state variables.
M_.nspred; % number of state variables

k2 = oo_.dr.inv_order_var(oo_.dr.state_var); % identification of states variables in the dr order
Nstates = length(k2); % can differ from M_.nspred for some parameter values

% Only one exogenous shock
% I simulate state-variables, and the varible j=24 ( for example) in the
% declaration order
Length_irf = 200;
j = find(contains(M_.endo_names,'PIt')); %j=24;  inflation in te declaration order
%j = find(contains(M_.endo_names,'tk')); %j=28;  inflation in te declaration order
nj = oo_.dr.inv_order_var(j); %dr order
jv = zeros(1,Length_irf);

States_vect = zeros(Nstates,Length_irf);


% To check that the I reproduce the IRF for inflatin
% exogenous shock at first period only
std = 0*0.0001^.5; % I use the variance coming from the dynare simulation above
States_vect(:,1) = oo_.dr.ghx(k2,1:Nstates)*zeros(Nstates,1) + oo_.dr.ghu(k2)*std;
jv(1)  = oo_.dr.ghx(nj,1:Nstates)*zeros(Nstates,1) + oo_.dr.ghu(nj)*std;


for i=2:Length_irf
        States_vect(:,i) = oo_.dr.ghx(k2,1:Nstates)* States_vect(:,i-1);
        jv(i)  = oo_.dr.ghx(nj,1:Nstates)* States_vect(:,i-1);
end
% check that jv is the same as the irf for inflation in "oo_.irfs.PIt_eps"

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 1) Reoptimizatio shock
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Now, I set the lambdat to the opposite of their steady state value (to start at
% 0) in addition I simulate the aggregate shock

% I want to plot 12 variables. I first find their index in the declaration
% order: ut_eps GDPt_eps Ct_eps wt_eps rt_eps Tt_eps Kt_eps PIt_eps tk_eps tl_eps mut_eps Bt_eps

%ut=17, GDPt=23,Ct=19, wt=21, rt=22, Tt=27, Kt=18, PIt=24, tk=28, tl=29,
%mut=30, Bt = 20 rtildeK=25 wtilde=26 Ltoy=11 FL =5 zeta =32


j = [17;23;19;21;22;27;18;24;28;29;30;20;25;26;11;5;32]; %declaration order
nj = oo_.dr.inv_order_var(j);
jv2 = zeros(length(nj),Length_irf);

d3 = [43:6:43+726*6]; % indices of lambda in the declaration order
k3 = oo_.dr.inv_order_var(d3); % lambda in the dr order
steady_l = oo_.dr.ys*0; % steady state values in the declaration order
steady_l(d3) = -oo_.dr.ys(d3); % only the lambda are fulfilled.

ind = find(contains(M_.endo_names,'Upsilon'));
steady_l(ind) = -oo_.dr.ys(ind); % Upsilon set to 0

ind = find(contains(M_.endo_names,'Lgamma'));
steady_l(ind) = -oo_.dr.ys(ind); % Upsilon set to 0



initv = steady_l(oo_.dr.order_var); % I put the initial vector in the dr order


% exogenous shock at first period only
States_vect(:,1) = oo_.dr.ghx(k2,1:Nstates)*initv(k2) + oo_.dr.ghu(k2)*std;
jv2(:,1)  = oo_.dr.ghx(nj,1:Nstates)*initv(k2) + oo_.dr.ghu(nj)*std;

for i=2:Length_irf
        States_vect(:,i) = oo_.dr.ghx(k2,1:Nstates)* States_vect(:,i-1);
        jv2(:,i)  = oo_.dr.ghx(nj,1:Nstates)* States_vect(:,i-1);
end


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 2) This part simulate an aggregate Wealth shock
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%load result_full % all result of the model.
% I reduce all the "a" by 1% for the type 1 to 4
% I give the residual to all type 5 agents in a equal way to insure A is
% constant.
%
d4 = [39:6:39+726*6]; % index of as in the declaration order
jv3 = zeros(length(nj),Length_irf);
steady_l = oo_.dr.ys*0; % steady state values in the declaration order
Sumd = 0;
Sum5=1e-5;

%Check sum(oo_.dr.ys(d4).*Sp)==eco.A
Sh=0.1;
for i=1:Nbin
  if eco.ytype(i)<=5
     steady_l(d4(i))=-oo_.dr.ys(d4(i))*Sh;%I introduce a negative reduction of Sh% of steady_state level
     Sumd=Sumd-oo_.dr.ys(d4(i))*Sh*Sp(i); % sum of negative deviation times the size
  else
      Sum5=Sum5+Sp(i);
  end
      
end
   
%steady_l(d4(find(eco.ytype==5))) = -Sumd/Sum5;
%steady_l(d4(end)) = -Sumd/Sp(end);
% Check sum(steady_l(d4).*Sp)==0

dK = 8; % indices of K in the declaration order
steady_l(dK) = -oo_.dr.ys(dK)*Sh; % The capital stock decreases by 10%

dA = 6; % indices of K in the declaration order
steady_l(dA) = -Sh*(eco.A-eco.B); %I reduce the capital stock and I keep the debt + -oo_.dr.ys(dA)*Sh; % The capital stock decreases by 10%

%steady_l = steady_l*0;

%dLgamma =335; % indices of Lgamma in the declaration order (no past philipps curve)
%steady_l(dLgamma) = -oo_.dr.ys(dLgamma); % The capital stock decreases by 10%




% In addition I set lamdas to 0 (to be logically consistent).
%d3 = [43:6:43+726*6]; % indices of lambda in the declaration order
%steady_l(d3) = -oo_.dr.ys(d3); % only the lambda are fulfilled.

ind = find(contains(M_.endo_names,'Upsilon'));
steady_l(ind) = -oo_.dr.ys(ind); % Upsilon set to 0

ind = find(contains(M_.endo_names,'Lgamma'));
steady_l(ind) = -oo_.dr.ys(ind); % Upsilon set to 0


initv = steady_l(oo_.dr.order_var); % I put the initial vector in the dr order

% exogenous shock at first period only
States_vect(:,1) = oo_.dr.ghx(k2,1:Nstates)*initv(k2) + oo_.dr.ghu(k2)*std;
jv3(:,1)  = oo_.dr.ghx(nj,1:Nstates)*initv(k2) + oo_.dr.ghu(nj)*std;

for i=2:Length_irf
        States_vect(:,i) = oo_.dr.ghx(k2,1:Nstates)* States_vect(:,i-1);
        jv3(:,i)  = oo_.dr.ghx(nj,1:Nstates)* States_vect(:,i-1);
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 3) This part simulate a redistribution shock
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%load result_full % all result of the model.
% I reduce all the "a" by 1% for the type 1 to 4
% I give the residual to all type 5 agents in a equal way to insure A is
% constant.
%
d4 = [39:6:39+726*6]; % index of as in the declaration order
jv4 = zeros(length(nj),Length_irf);
steady_l = oo_.dr.ys*0; % steady state values in the declaration order
Sumd = 0;
Sum5=1e-5;

%Check sum(oo_.dr.ys(d4).*Sp)==eco.A
Sh=-0.1;
for i=1:Nbin
  if eco.ytype(i)==2||eco.ytype(This increases i)==1
     steady_l(d4(i))=-oo_.dr.ys(d4(i))*Sh;%I introduce a negative reduction of Sh% of steady_state level
     Sumd=Sumd-oo_.dr.ys(d4(i))*Sh*Sp(i); % sum of negative deviation times the size
  else
      Sum5=Sum5+Sp(i);
  end
      
end
XX = Sumd/(sum(Sp(find(eco.ytype==4)))+sum(Sp(find(eco.ytype==5))));   

%steady_l(d4(find(eco.ytype==4))) = -Sumd/Sum5;

steady_l(d4(find(eco.ytype==4))) = -XX;
steady_l(d4(find(eco.ytype==5))) = -XX;


%steady_l(d4(end)) = -Sumd/Sp(end);


%dK = 8; % indices of K in the declaration order
%steady_l(dK) = -oo_.dr.ys(dK)*Sh*0; % The capital stock decreases by 10%

%dA = 6; % indices of K in the declaration order
%steady_l(dA) = (1-Sh*0)*(eco.A-eco.B)+eco.B; %I reduce the capital stock and I keep the debt + -oo_.dr.ys(dA)*Sh; % The capital stock decreases by 10%


%steady_l = steady_l*0;

%dLgamma =335; % indices of Lgamma in the declaration order (no past philipps curve)
%steady_l(dLgamma) = -oo_.dr.ys(dLgamma); % The capital stock decreases by 10%




% In addition I set lamdas to 0 (to be logically consistent).
%d3 = [43:6:43+726*6]; % indices of lambda in the declaration order
%steady_l(d3) = -oo_.dr.ys(d3); % only the lambda are fulfilled.

ind = find(contains(M_.endo_names,'Upsilon'));
steady_l(ind) = -oo_.dr.ys(ind); % Upsilon set to 0

ind = find(contains(M_.endo_names,'Lgamma'));
steady_l(ind) = -oo_.dr.ys(ind); % Upsilon set to 0


initv = steady_l(oo_.dr.order_var); % I put the initial vector in the dr order

% exogenous shock at first period only
States_vect(:,1) = oo_.dr.ghx(k2,1:Nstates)*initv(k2) + oo_.dr.ghu(k2)*std;
jv4(:,1)  = oo_.dr.ghx(nj,1:Nstates)*initv(k2) + oo_.dr.ghu(nj)*std;

for i=2:Length_irf
        States_vect(:,i) = oo_.dr.ghx(k2,1:Nstates)* States_vect(:,i-1);
        jv4(:,i)  = oo_.dr.ghx(nj,1:Nstates)* States_vect(:,i-1);
end





%jv3 is now in the dr order, back to the declation order
save tofigaggtime0 jv2 jv3 jv4
toc
%%
num = 14;
disp(M_.endo_names(j(num)));
close all;
plot(jv2(num,:)); 
hold on
plot(jv3(num,:),'r--'); 
hold off
%%

